/*
 * $Id$
 */

#include <sys/types.h>
#include <asm-i386/stat.h>
#include <asm-i386/unistd.h>
#include <linux/types.h>
#include <linux/dirent.h>

#define __syscall_return(type, res) \
do { \
	if ((unsigned long)(res) >= (unsigned long)(-125)) { \
		res = -1; \
	} \
	return (type) (res); \
} while (0)

#define __syscall0(type,name) \
type name(void) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name)); \
__syscall_return(type,__res); \
}

#define __syscall1(type,name,type1,arg1) \
type name(type1 arg1) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1))); \
__syscall_return(type,__res); \
}

#define __syscall2(type,name,type1,arg1,type2,arg2) \
type name(type1 arg1,type2 arg2) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2))); \
__syscall_return(type,__res); \
}

#define __syscall3(type,name,type1,arg1,type2,arg2,type3,arg3) \
type name(type1 arg1,type2 arg2,type3 arg3) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
		  "d" ((long)(arg3))); \
__syscall_return(type,__res); \
}

#define __syscall4(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4) \
type name (type1 arg1, type2 arg2, type3 arg3, type4 arg4) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
	  "d" ((long)(arg3)),"S" ((long)(arg4))); \
__syscall_return(type,__res); \
}

#define __syscall5(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4, \
	  type5,arg5) \
type name (type1 arg1,type2 arg2,type3 arg3,type4 arg4,type5 arg5) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
	  "d" ((long)(arg3)),"S" ((long)(arg4)),"D" ((long)(arg5))); \
__syscall_return(type,__res); \
}

#define __syscall6(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4, \
	  type5,arg5,type6,arg6) \
type name (type1 arg1,type2 arg2,type3 arg3,type4 arg4,type5 arg5,type6 arg6) \
{ \
long __res; \
__asm__ volatile ("push %%ebp ; movl %%eax,%%ebp ; movl %1,%%eax ; int $0x80 ; pop %%ebp" \
	: "=a" (__res) \
	: "i" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
	  "d" ((long)(arg3)),"S" ((long)(arg4)),"D" ((long)(arg5)), \
	  "0" ((long)(arg6))); \
__syscall_return(type,__res); \
}


/*
 * f**king x86 ! no support for -mno-prologue-epilogue neither for the naked attribute
__attribute__((naked)) static inline __syscall3(int, write, int, fd, const void *, buf, size_t, count)
*/
static inline __syscall3(int, write, int, fd, const void *, buf, size_t, count)
static inline __syscall3(int, read, int, fd, void *, buf, size_t, count)
static inline __syscall0(pid_t, getpid)
static inline __syscall1(int, exit, int, status)
static inline __syscall3(int, readdir, unsigned int, fd, struct dirent *, dirp,
						unsigned int, count)
static inline __syscall3(int, open, const char *, pathname, int, flags, int, mode)
static inline __syscall1(int, close, int, fd)
static inline __syscall2(int, access, const char *, pathname, int, mode)
static inline __syscall2(int, stat, const char *, path, struct stat *, buf)
static inline __syscall1(int, brk, void *, end_data_segment)
static inline __syscall2(int, lstat, const char *, path, struct stat *, buf)


#define STDOUT	1


int main(int argc, char *argv[])
{
	char hi_there[]="hi there !\n";

	write(STDOUT, hi_there, sizeof(hi_there));

	exit(0);

	/* never reached */
	return 0;
}
